#!/bin/sh
# @version $Id: statusreturn.sh,v 2.4.1.1 2003/12/12 22:24:21 fredo Exp $
# @copyright 2003 

# call : statusreturn.sh hostname with_service_restriction
# return global status (red,yellow,purple,blue,clear,green) as (1-6)
# follow by each service by status (1-6)
# default : global status = first from red,yellow,purple,blue,clear,green in this order
# change if needed
BBVAR="/usr/local/bbvar"

ulimit -t 3

HOST=`echo $1 | sed 's/\\./,/g'`

if [ "$#" -eq "1" ]
then
  SERVICE=`ls -1 ${BBVAR}/hist/${HOST}.*`
else
  LISTSERV=`echo $2 | sed 's/:/ /g'`
  SERVICE=""
  for I in ${LISTSERV} 
  do
    if [ -r ${BBVAR}/hist/${HOST}.${I} ]
	then
	  SERVICE="${SERVICE} ${BBVAR}/hist/${HOST}.${I}"
	fi
  done
fi
status=6
redservice=""
yellowservice=""
purpleservice=""
blueservice=""
clearservice=""
greenservice=""

for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "red"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${redservice}" = "" ]
	  then
	  redservice=${toadd}
      else
	  redservice=${redservice},${toadd}
      fi
      status=1
  fi
done
for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "yellow"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${yellowservice}" = "" ]
	  then
	  yellowservice=${toadd}
      else
	  yellowservice=${yellowservice},${toadd}
      fi
      if [ ${status} -gt 2 ]
	  then
	  status=2
      fi
  fi
done
for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "purple"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${purpleservice}" = "" ]
	  then
	  purpleservice=${toadd}
      else
	  purpleservice=${purpleservice},${toadd}
      fi
      if [ ${status} -gt 3 ]
	  then
	  status=3
      fi
  fi
done
for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "blue"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${blueservice}" = "" ]
	  then
	  blueservice=${toadd}
      else
	  blueservice=${blueservice},${toadd}
      fi
      if [ ${status} -gt 4 ]
	  then
	  status=4
      fi
  fi
done
for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "clear"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${clearservice}" = "" ]
	  then
	  clearservice=${toadd}
      else
	  clearservice=${clearservice},${toadd}
      fi
      if [ ${status} -gt 5 ]
	  then
	  status=5
      fi
  fi
done
for I in ${SERVICE}
do
  service=`tail -1 ${I} | grep -w "green"`
  if [ "$?" -eq "0" ]
  then
      toadd=`echo ${I} | cut -d. -f2`
      if [ "${greenservice}" = "" ]
	  then
	  greenservice=${toadd}
      else
	  greenservice=${greenservice},${toadd}
      fi
  fi
done

echo ${status}:${redservice}:${yellowservice}:${purpleservice}:${blueservice}:${clearservice}:${greenservice}
